#!/bin/sh

set -e

cd $(dirname $0)

. ../../common/config.sh
. ../../common/log.sh

log_start "$0" "Add a new user with a specified unexisting GID"

save_config

# restore the files on exit
trap 'log_status "$0" "FAILURE"; restore_config' 0

change_config

echo -n "Create user test1 (useradd -g 4242 test1)..."
useradd -g 4242 test1 2>tmp/useradd.err && exit 1 || {
	status=$?
}
echo "OK"
echo "OK"
echo "All right, useradd returned error $status."
echo -n "Check returned status..."
test "$status" = "6"
echo "OK"

echo "useradd displayed:"
echo "======================================================================="
cat tmp/useradd.err
echo "======================================================================="
echo -n "Check that there were a failure message..."
diff -au 05_useradd_invalid_numeric_primary_group/useradd.err tmp/useradd.err
echo "error message OK."
rm -f tmp/useradd.err

echo -n "Check the passwd file..."
../../common/compare_file.pl config/etc/passwd /etc/passwd
echo "OK"
echo -n "Check the group file..."
../../common/compare_file.pl config/etc/group /etc/group
echo "OK"
echo -n "Check the shadow file..."
../../common/compare_file.pl config/etc/shadow /etc/shadow
echo "OK"
echo -n "Check the gshadow file..."
../../common/compare_file.pl config/etc/gshadow /etc/gshadow
echo "OK"
echo -n "no homedir..."
test -d /home/test1 && exit 1 || true
echo "OK"

log_status "$0" "SUCCESS"
restore_config
trap '' 0

